import asyncio
from datetime import datetime
from aiohttp import web
import random
import os

random.seed(1)

async def hello(request):
    name = request.match_info.get("name", "foo")
    n = datetime.now()
    delay = random.randint(0, 3)
    await asyncio.sleep(delay)
    headers = {"content_type": "text/html", "delay": str(delay)}
    fn = os.path.join(os.path.dirname(__file__), 'index.html')
    with open(fn, "rb") as html_body:
        print("{}: {} delay: {}".format(n, request.path, delay))
        response = web.Response(body=html_body.read(), headers=headers)
    return response

app = web.Application()
app.router.add_route("GET", "/{name}", hello)
web.run_app(app)
